// Ionic Starter App
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'angular-sortable-view', 'starter.controllers', 'starter.services', 'starter.directive', 'ngCordova', 'ionicLazyLoad'])
    .run(function ($ionicPlatform, $timeout, $location, $rootScope, IsOrNotToast, $ionicHistory, $cordovaKeyboard, jpushService, $state, appVersion, Config, $ionicPopup, $ionicLoading, $cordovaFileTransfer, $cordovaFileOpener2) {
        $ionicPlatform.ready(function () {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(true);
            }
            if (window.StatusBar) {
                // org.apache.cordova.statusbar required
                StatusBar.styleDefault();
//                StatusBar.styleBlackOpaqu();
//                StatusBar.backgroundColorByHexString("#ffffff");
            }
            //推送初始化
            var setTagsWithAliasCallback = function (event) {
                console.log('result code:' + event.resultCode + ' tags:' + event.tags + ' alias:' + event.alias);
            }
            var openNotificationInAndroidCallback = function (data) {
                var json = data;
                if (typeof data === 'string') {
                    json = JSON.parse(data);
                }
                var id = json.extras.pushId;
                var item = {};
                item.id = id;
                //window.alert(id);
                $state.go("homeDetail", {"id": item.id}, {reload: true});
            }
            var config = {
                stac: setTagsWithAliasCallback,
                oniac: openNotificationInAndroidCallback
            };
            jpushService.init(config);
            $timeout(function () {
                var onGetRegistradionID = function (data) {
                    try {
                        window.localStorage.userId = data;
                    } catch (exception) {
                    }
                };
                window.plugins.jPushPlugin.getRegistrationID(onGetRegistradionID);
            }, 2000);
            //检测更新
            checkUpdate();
            if (window.plugins && window.plugins.splashscreen) {
                $timeout(function () {
                    navigator.splashscreen.hide();
                }, 1000);
            }
        });
        //软件升级
        var checkUpdate = function () {
            appVersion.getVersion(function (data) {
                if (data.result == 0) {
                    if (Config.currentVersion * 1 < data.datas.version * 1) {
                        var confirmPopup = $ionicPopup.confirm({
                            title: '版本升级',
                            template: data.datas.description, //从服务端获取更新的内容
                            cancelText: '取消',
                            okText: '升级'
                        });
                        confirmPopup.then(function (res) {
                            if (res) {
                                $ionicLoading.show({
                                    template: "已经下载：0%"
                                });
                                var url = data.datas.download; //可以从服务端获取更新APP的路径
                                var targetPath = cordova.file.externalDataDirectory + "中国苏州.apk"
                                var trustHosts = true;
                                var options = {};
                                $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
                                    // 打开下载下来的APP
                                    $cordovaFileOpener2.open(targetPath, 'application/vnd.android.package-archive'
                                    ).then(function () {
                                        // 成功
                                    }, function (err) {
                                        // 错误
                                    });
                                    $ionicLoading.hide();
                                }, function (err) {
                                    IsOrNotToast.toast('下载失败');
                                    $ionicLoading.hide();
                                }, function (progress) {
                                    //进度，这里使用文字显示下载百分比
                                    $timeout(function () {
                                        var downloadProgress = (progress.loaded / progress.total) * 100;
                                        $ionicLoading.show({
                                            template: "已经下载：" + Math.floor(downloadProgress) + "%",
                                        });
                                        if (downloadProgress > 99) {
                                            $ionicLoading.hide();
                                        }
                                    }, 1000);
                                });
                            } else {
                                //取消更新
                            }
                            ';'
                        })
                    } else if (Config.currentVersion * 1 >= data.datas.version * 1) {
                        IsOrNotToast.toast("该版本已是最新版本");
                    }
                } else {
                    IsOrNotToast.toast(data.message);
                }
            })
        };
        //双击退出
        $ionicPlatform.registerBackButtonAction(function (e) {
            //判断处于哪个页面时双击退出
            if ($location.path() == '/root/tab/home' || $location.path() == '/root/tab/officeHallCenter') {
                if ($rootScope.backButtonPressedOnceToExit) {
                    ionic.Platform.exitApp();
                } else {
                    $rootScope.backButtonPressedOnceToExit = true;
                    IsOrNotToast.toast('再按一次退出系统');
                    setTimeout(function () {
                        $rootScope.backButtonPressedOnceToExit = false;
                    }, 2000);
                }
            } else if ($ionicHistory.backView()) {
                if ($cordovaKeyboard.isVisible()) {
                    $cordovaKeyboard.close();
                } else {
                    $ionicHistory.goBack(-1);
                }
            } else {
                if ($rootScope.backButtonPressedOnceToExit) {
//                    window.localStorage.clear();
                    ionic.Platform.exitApp();
                } else {
                    $rootScope.backButtonPressedOnceToExit = true;
                    IsOrNotToast.toast('再按一次退出系统');
                    setTimeout(function () {
                        $rootScope.backButtonPressedOnceToExit = false;
                    }, 2000);
                }
            }
            e.preventDefault();
            return false;
        }, 101);
    })
    .config(['$stateProvider', '$urlRouterProvider', '$ionicConfigProvider', '$sceDelegateProvider', '$httpProvider', function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $sceDelegateProvider, $httpProvider) {
        $ionicConfigProvider.platform.ios.tabs.style('standard');
        $ionicConfigProvider.platform.ios.tabs.position('bottom');
        $ionicConfigProvider.platform.android.tabs.style('standard');
        $ionicConfigProvider.platform.android.tabs.position('bottom');
        $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
        $ionicConfigProvider.platform.android.navBar.alignTitle('center');
        $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
        $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');
        $ionicConfigProvider.platform.ios.views.transition('ios');
        $ionicConfigProvider.platform.android.views.transition('android');
        $stateProvider
        // setup an abstract state for the tabs directive
            .state('root', {
                url: '/root',
                abstract: true,
                templateUrl: 'templates/roots.html',
                controller: 'rootsController'
            })
            .state('root.tab', {
                url: '/tab',
                views: {
                    'tabs': {
                        templateUrl: 'templates/tabs.html',
                        controller: 'tabsController'
                    }
                }
            })
            .state('root.tab.home', {
                url: '/home',
                views: {
                    'home-page': {
                        templateUrl: 'templates/informationList.html',
                        controller: 'informationListController'
                    }
                }
            })
            .state('homeDetail', {
                cache: false,
                url: '/homeDetail/:id/:docSource/:nickcrUser',
                templateUrl: 'templates/informationDetail.html',
                controller: 'informationDetailController'
            })
            .state('userCollect', {
                cache: false,
                url: '/userCollect',
                templateUrl: 'templates/collect.html',
                controller: 'userCollectController'
            })
            .state('root.tab.officeHallCenter', {
                url: '/officeHallCenter',
                views: {
                    'officeHall-page': {
                        templateUrl: 'templates/officeHallCenter.html',
                        controller: 'officeHallCenterController'
                    }
                }
            })
            .state('root.tab.mobileOffice', {
                url: '/mobileOfficeCenter',
                views: {
                    'mobileOffice-page': {
                        templateUrl: 'templates/mobileOfficeCenter.html',
                        controller: 'mobileOfficeController'
                    }
                }
            })
        ;
        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/root/tab/home');
    }]);
