angular.module('starter.controllers', [])
    .controller('modalBasicCtrl', ['$scope', 'Storage', '$ionicModal', '$ionicScrollDelegate', '$ionicSlideBoxDelegate', '$ionicSideMenuDelegate', '$rootScope', function ($scope, Storage, $ionicModal, $ionicScrollDelegate, $ionicSlideBoxDelegate, $ionicSideMenuDelegate, $rootScope) {
        //栏目弹窗
        $ionicModal.fromTemplateUrl('templates/category.html', {
            scope: $scope,
            animation: 'slide-in-index'
        }).then(function (modal) {
            $scope.newTopicModal = modal;
        });
        $scope.openCategoryModal = function (event, type) {
            $scope.is_close = false;
            $scope.type = type;
            $scope.newTopicModal.show();
            document.addEventListener('backbutton', $scope.closeCategoryModal, false);
            //推荐栏目
            if (Storage.get('categoryListMyColumn') && Storage.get('categoryListMyColumn').length > 1) {
                $rootScope.categoryListMyColumn = Storage.get('categoryListMyColumn');
            }
            //其它栏目
            if (Storage.get('categoryListOtherColumn') && Storage.get('categoryListOtherColumn').length >= 1) {
                $rootScope.categoryListOtherColumn = Storage.get('categoryListOtherColumn');
            }
            $scope.sortableOptions = {
                containment: '#horizontal-container',
                //restrict move across columns. move only within column.
                accept: function (sourceItemHandleScope, destSortableScope) {
                    return sourceItemHandleScope.itemScope.sortableScope.$id === destSortableScope.$id;
                }
            };
        };
        // 关闭栏目编辑
        $scope.closeCategoryModal = function () {
            $scope.newTopicModal.hide();
            document.removeEventListener('backbutton', $scope.closeCategoryModal, false);
            $ionicScrollDelegate.$getByHandle('column_scroll').resize();
            $scope.all_cate_num = $rootScope.categoryListMyColumn.length;
            $rootScope.all_cate_width = $scope.all_cate_num * 25 + '%';
            var a = document.getElementById('sub_header_list').getElementsByTagName('a');
            for (var i = 0; i < $scope.all_cate_num; i++) {
                a[i].className = "button button-clear ";
            }
            if ($rootScope.categoryListMyColumn.length - 1 >= $rootScope.currentSectionIndexIndex && $rootScope.currentSectionIndexId == $rootScope.categoryListMyColumn[$rootScope.currentSectionIndexIndex].id) {
                a[$rootScope.currentSectionIndexIndex].className = "button button-clear sub_button_select";
                return;
            }
            for (var i = 0; i < $rootScope.categoryListMyColumn.length; i++) {
                if ($rootScope.currentSectionIndexId == $rootScope.categoryListMyColumn[i].id) {
                    $rootScope.currentSectionIndexIndex = i;
                    a[$rootScope.currentSectionIndexIndex].className = "button button-clear sub_button_select";
                    $ionicScrollDelegate.$getByHandle('column_scroll').scrollTo($rootScope.currentSectionIndexIndex * ($scope.ScreenWidth / 4) - 50, 0, true);
                    return;
                } else {
                    if (i == $rootScope.categoryListMyColumn.length - 1) {
                        if ($rootScope.categoryListMyColumn.length - 1 >= $rootScope.currentSectionIndexIndex) {
                            $rootScope.changeTab($rootScope.categoryListMyColumn[$rootScope.currentSectionIndexIndex].id, $rootScope.currentSectionIndexIndex);
                        } else {
                            $rootScope.changeTab($rootScope.categoryListMyColumn[$rootScope.categoryListMyColumn.length - 1].id, $rootScope.categoryListMyColumn.length - 1);
                        }
                    }
                }
            }
        };
        //栏目滑动排序变换后数据
        $scope.foo = function (item, partFrom, partTo, indexFrom, indexTo) {
            Storage.set('categoryListMyColumn', $rootScope.categoryListMyColumn);
            Storage.set('categoryListOtherColumn', $rootScope.categoryListOtherColumn);
        };
        //编辑我的栏目
        $scope.cateDeleteAll = function () {
            $scope.is_close = true;
        };
        //我的栏目编辑完成
        $scope.cateNoDelete = function () {
            $scope.is_close = false;
        };
        //增加栏目页面
        $scope.addMyTab = function (catid, key, catename) {
            if (!$scope.is_close) {
                return;
            }
            $rootScope.categoryListOtherColumn.splice(key, 1);
            $rootScope.categoryListMyColumn.push({
                'id': catid,
                'name': catename
            });
            /* $scope.all_cate_num = $rootScope.categoryListMyColumn.length;
             $rootScope.all_cate_width = $scope.all_cate_num * 25 + '%';*/
            Storage.set('categoryListMyColumn', $rootScope.categoryListMyColumn);
            Storage.set('categoryListOtherColumn', $rootScope.categoryListOtherColumn);
        };
        //点击我的栏目分类
        $scope.cateChangeTab = function (catid, key, catename) {
            if ($scope.type == 1) {
                $ionicSideMenuDelegate.toggleLeft();
            }
            //进入我的栏目列表
            if ($scope.is_close != true) {
                $scope.newTopicModal.hide();
                if ($rootScope.currentSectionIndexId != catid) {
                    $rootScope.changeTab(catid, key);
                } else {
                    $scope.all_cate_num = $rootScope.categoryListMyColumn.length;
                    var a = document.getElementById('sub_header_list').getElementsByTagName('a');
                    for (var i = 0; i < $scope.all_cate_num; i++) {
                        a[i].className = "button button-clear ";
                    }
                    //把之前那个栏目显示出来
                    a[$rootScope.currentSectionIndexIndex].className = "button button-clear sub_button_select";
                }
            } else {
                if (catid == 'http://www.suzhou.gov.cn/sy/app/rdtj/index.htm') {
                    return;
                }
                //删除我的栏目
                $rootScope.categoryListMyColumn.splice(key, 1);
                //改变分类的长度
                /*   $scope.all_cate_num = $rootScope.categoryListMyColumn.length;
                 $rootScope.all_cate_width = $scope.all_cate_num * 25 + '%';*/
                $rootScope.categoryListOtherColumn.unshift({
                    'id': catid,
                    'name': catename
                });
                if ($rootScope.categoryListMyColumn.length == 1) {
                    $scope.is_close = false;
                }
                Storage.set('categoryListMyColumn', $rootScope.categoryListMyColumn);
                Storage.set('categoryListOtherColumn', $rootScope.categoryListOtherColumn);
            }
        };
    }])
    .controller('rootsController', ['$scope', '$state', '$ionicPopup', '$ionicModal', '$ionicLoading', 'IsOrNotToast', '$timeout', '$controller', 'appVersion', 'Config', '$cordovaFileTransfer', '$cordovaFileOpener2', '$ionicSlideBoxDelegate', '$ionicPopup', 'Information', 'downloadImage', function ($scope, $state, $ionicPopup, $ionicModal, $ionicLoading, IsOrNotToast, $timeout, $controller, appVersion, Config, $cordovaFileTransfer, $cordovaFileOpener2, $ionicSlideBoxDelegate, $ionicPopup, Information, downloadImage) {
        $scope.all_cate_num = 1; //定义默认的导航数量
        $scope.ScreenWidth = window.innerWidth   //获取屏幕的宽度
            || document.documentElement.clientWidth
            || document.body.clientWidth;
        $controller('modalBasicCtrl', {$scope: $scope});
        /*        $scope.goToUserCollect = function () {

         };*/
        if (!window.cordova) {
            window.localStorage.userId = '160a3797c80a80933ec';
        }
        //我的收藏
        $scope.openUserCollectModal = function () {
            $state.go('userCollect', {reload: true});
        };
        //问题反馈
        $ionicModal.fromTemplateUrl('templates/feedback.html', {
            scope: $scope,
            animation: 'slide-in-index'
        }).then(function (modal) {
            $scope.feedbackModal = modal;
        });
        $scope.openFeedbackModal = function () {
            $scope.feedbackModal.show();
        };
        $scope.closeFeedbackModal = function () {
            $scope.feedbackDescribe.describe = '';
            $scope.feedbackModal.hide();
        };
        $scope.$on('$ionicView.afterEnter', function () {
            $('#feedbackTextId').focus();
        });
        var feedbackText = {
            describe: ''
        };
        $scope.feedbackDescribe = feedbackText;
        $scope.submitFeedback = function () {
            if ($scope.feedbackDescribe.describe == '') {
                IsOrNotToast.toast("请输入反馈内容");
                return;
            }
            Information.submit($scope.feedbackDescribe.describe, window.localStorage.userId, function (data) {
                if (data.result == '0') {
                    IsOrNotToast.toast("提交成功");
                    $scope.feedbackDescribe.describe = '';
                    $scope.feedbackModal.hide();
                } else {
                    IsOrNotToast.toast(data.message);
                }
            })
        };
        //联系我们
        $scope.connect = function () {
            window.open('http://www.suzhou.gov.cn/sy/app/lxwm.html', '_system');
        };
        //清除缓存
        $scope.goClearCache = function () {
            if (!window.cordova) {
                alert('此功能在移动设备上测试');
                return;
            }
            var confirmPopup = $ionicPopup.confirm({
                title: '清理缓存数据',
                template: '缓存文件可以用来帮您节省流量，但较大时会占用较多磁盘空间。确定开始清理吗？',
                cancelText: '取消',
                okText: '确认'
            });
            confirmPopup.then(function (res) {
                if (res) {
                    downloadImage.removeDir(function (data) {
                        $timeout(function () {
                            if (data == 1) {
                                IsOrNotToast.toast("缓存已清理完成");
                                //$rootScope.totalSize = '0.0kb';
                            } else {
                                IsOrNotToast.toast("缓存清理失败");
                            }
                        }, 1000);
                    })
                }
            });
        };
        $scope.currentVersion = Config.currentVersion;
        //软件升级
        $scope.checkUpdate = function () {
            appVersion.getVersion(function (data) {
                if (data.result == 0) {
                    if (Config.currentVersion * 1 < data.datas.version * 1) {
                        var confirmPopup = $ionicPopup.confirm({
                            title: '版本升级',
                            template: data.datas.description, //从服务端获取更新的内容
                            cancelText: '取消',
                            okText: '升级'
                        });
                        confirmPopup.then(function (res) {
                            if (res) {
                                $ionicLoading.show({
                                    template: "已经下载：0%"
                                });
                                var url = data.datas.download; //可以从服务端获取更新APP的路径
                                var targetPath = cordova.file.externalDataDirectory + "中国苏州.apk"
                                var trustHosts = true;
                                var options = {};
                                $cordovaFileTransfer.download(url, targetPath, options, trustHosts).then(function (result) {
                                    // 打开下载下来的APP
                                    $cordovaFileOpener2.open(targetPath, 'application/vnd.android.package-archive'
                                    ).then(function () {
                                        // 成功
                                    }, function (err) {
                                        // 错误
                                    });
                                    $ionicLoading.hide();
                                }, function (err) {
                                    IsOrNotToast.toast('下载失败');
                                    $ionicLoading.hide();
                                }, function (progress) {
                                    //进度，这里使用文字显示下载百分比
                                    $timeout(function () {
                                        var downloadProgress = (progress.loaded / progress.total) * 100;
                                        $ionicLoading.show({
                                            template: "已经下载：" + Math.floor(downloadProgress) + "%",
                                        });
                                        if (downloadProgress > 99) {
                                            $ionicLoading.hide();
                                        }
                                    }, 1000);
                                });
                            } else {
                                //取消更新
                            }
                        })
                    } else if (Config.currentVersion * 1 >= data.datas.version * 1) {
                        IsOrNotToast.toast("该版本已是最新版本");
                    }
                } else {
                    IsOrNotToast.toast(data.message);
                }
            })
        };
    }])
    .controller('tabsController', ['$scope', '$ionicModal', '$controller', 'Storage', 'Section', '$interval', '$timeout', '$ionicLoading', '$ionicScrollDelegate', '$ionicSlideBoxDelegate', '$ionicSideMenuDelegate', 'Media', '$rootScope', '$state', 'Information', 'downloadImage', function ($scope, $ionicModal, $controller, Storage, Section, $interval, $timeout, $ionicLoading, $ionicScrollDelegate, $ionicSlideBoxDelegate, $ionicSideMenuDelegate, Media, $rootScope, $state, Information, downloadImage) {
        $controller('modalBasicCtrl', {$scope: $scope});
        /*        $scope.$on('$ionicView.afterEnter', function () {
         alert(136)
         });*/
        $scope.moreData = true;
        $scope.pageSize = 20;
        $scope.moreDataCanBeLoaded = true;
        $rootScope.categoryListMyColumn = [{
            "name": "热点推荐",
            "id": "http://www.suzhou.gov.cn/sy/app/rdtj/index.htm"
        }];
        $rootScope.categoryListOtherColumn = [];
        if ($scope.mediaTimer == null) {
            $scope.mediaTimer = $interval(function () {
                Media.resizeImg();
            }, 100);
        }
        $scope.refresh = function () {
            $scope.pageNo = 1;
            $scope.moreData = true;
            $scope.topInforState = true;
            if (Storage.get('categoryListOtherColumn') == undefined) {
                $scope.sectionLoading = false;
                if ($scope.sectionLoading) {
                    $scope.$broadcast('scroll.refreshComplete');
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    return;
                }
                Section.querySections(function (datas) {
                    $scope.sectionLoading = true;
                    if (datas != "-1") {
                        for (var i = 0; i < datas.length; i++) {
                            if ('http://english.suzhou.gov.cn/index_1427.shtml' == datas[i].id) {
                                continue;
                            }
                            if (datas.length - 1 > 3) {
                                if (i >= 3) {
                                    $rootScope.categoryListOtherColumn.push(datas[i]);
                                } else {
                                    $rootScope.categoryListMyColumn.push(datas[i]);
                                }
                            } else {
                                $rootScope.categoryListMyColumn.push(datas[i]);
                            }
                        }
                        $rootScope.currentSectionIndexId = $rootScope.categoryListMyColumn[0].id;
                        $scope.loadData(false);
                        var a = document.getElementById('sub_header_list').getElementsByTagName('a');
                        for (var i = 0; i < $scope.all_cate_num; i++) {
                            a[i].className = "button button-clear ";
                        }
                        //把之前那个栏目显示出来
                        $rootScope.currentSectionIndexIndex = 0;
                        a[$rootScope.currentSectionIndexIndex].className = "button button-clear sub_button_select";
                        $scope.all_cate_num = $rootScope.categoryListMyColumn.length;
                        $rootScope.all_cate_width = $scope.all_cate_num * 25 + '%';
                    }
                    $scope.$broadcast('scroll.refreshComplete');
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                })
            } else {
                $scope.loadData(false);
            }
        };
        $scope.loadMore = function () {
            $scope.topInforState = false;
            if (!$scope.moreData) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }
            $scope.pageNo++;
            $scope.loadData(true);
        };
        $ionicLoading.show();
        $scope.topInforState = true;
        //获取栏目
        Section.querySections(function (datas) {
            if (datas != "-1") {
                for (var i = 0; i < datas.length; i++) {
                    if ('http://english.suzhou.gov.cn/index_1427.shtml' == datas[i].id) {
                        continue;
                    }
                    if (datas.length - 1 > 3) {
                        if (i >= 3) {
                            $rootScope.categoryListOtherColumn.push(datas[i]);
                        } else {
                            $rootScope.categoryListMyColumn.push(datas[i]);
                        }
                    } else {
                        $rootScope.categoryListMyColumn.push(datas[i]);
                    }
                }
                $rootScope.currentSectionIndexId = $rootScope.categoryListMyColumn[0].id;
                $scope.pageNo = 1;
                $scope.loadData(false);
            }
            $ionicLoading.hide();
            var a = document.getElementById('sub_header_list').getElementsByTagName('a');
            for (var i = 0; i < $scope.all_cate_num; i++) {
                a[i].className = "button button-clear ";
            }
            //把之前那个栏目显示出来
            $rootScope.currentSectionIndexIndex = 0;
            a[$rootScope.currentSectionIndexIndex].className = "button button-clear sub_button_select";
            //我的栏目
            if (Storage.get('categoryListMyColumn') && Storage.get('categoryListMyColumn').length > 1) {
                $rootScope.categoryListMyColumn = Storage.get('categoryListMyColumn');
            } else {
                if ($rootScope.categoryListMyColumn.length >= 1) {
                    Storage.set('categoryListMyColumn', $rootScope.categoryListMyColumn);
                }
            }
            $scope.all_cate_num = $rootScope.categoryListMyColumn.length;
            $rootScope.all_cate_width = $scope.all_cate_num * 25 + '%';
            //推荐栏目
            if (Storage.get('categoryListOtherColumn') && Storage.get('categoryListOtherColumn').length > 1) {
                $rootScope.categoryListOtherColumn = Storage.get('categoryListOtherColumn');
            } else {
                if ($rootScope.categoryListOtherColumn.length >= 1) {
                    Storage.set('categoryListOtherColumn', $rootScope.categoryListOtherColumn);
                }
            }
        });
        if ($rootScope.currentSectionIndexIndex != null) {
            $rootScope.currentSectionIndexIndex = 0;
            var a = document.getElementById('sub_header_list').getElementsByTagName('a');
            for (var i = 0; i < $scope.all_cate_num; i++) {
                a[i].className = "button button-clear ";
            }
            a[$rootScope.currentSectionIndexIndex].className = "button button-clear sub_button_select";
        }
        //加载数据
        $scope.loadData = function (append) {
            if (!$scope.moreData) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }
            if (!append) {
                if (!$scope.$$phase) {
                    $scope.$apply(function () {
                        $scope.listInformation = [];
                    });
                } else {
                    $scope.listInformation = [];
                }
            }
            $scope.moreData = false;
            if ($scope.topInforState == true && $rootScope.currentSectionIndexId == 'http://www.suzhou.gov.cn/sy/app/rdtj/index.htm') {
                $scope.topInformations = '';
                $scope.datasetData = '';
                Information.hotTopInformations(function (data) {
                    if (data.result == 0) {
                        $scope.topInformations = data.datas.queryTopBanInformations;
                        $scope.datasetData = data.datas.queryTopNewInformations;
                        $rootScope.topInforSlideStop = $timeout(function () {
                            $scope.$apply(function () {
                                $ionicSlideBoxDelegate.$getByHandle('topInforSlide').update();
                                var curIndex = $ionicSlideBoxDelegate.$getByHandle('topInforSlide').currentIndex();
                                var maxIndex = $ionicSlideBoxDelegate.$getByHandle('topInforSlide').slidesCount() - 1;
                                var nextIndex = (curIndex >= maxIndex) ? 0 : curIndex + 1;
                                $ionicSlideBoxDelegate.$getByHandle('topInforSlide').slide(nextIndex);
                            });
                        }, 2000);
                    }
                });
            }
            Information.queryInformations($rootScope.currentSectionIndexId, window.localStorage.userId, $scope.pageNo, $scope.pageSize, function (datas) {
                if (datas != "-1") {
                    $scope.moreData = datas.length > 0;
                    if (datas.length == $scope.pageSize) {
                        $scope.moreDataCanBeLoaded = true;
                    } else {
                        $scope.moreDataCanBeLoaded = false;
                    }
                    for (var i = 0; i < datas.length; i++) {
                        $scope.listInformation.push(datas[i]);
                    }
                }
                $ionicLoading.hide();
                // 停止广播on-infinite
                $scope.$broadcast('scroll.refreshComplete');
                $scope.$broadcast('scroll.infiniteScrollComplete');
            });
        };
        //点击tab的时候改变内容
        $rootScope.changeTab = function (patch, index) {
            if ($rootScope.currentSectionIndexId == 'http://www.suzhou.gov.cn/sy/app/rdtj/index.htm') {
                $scope.topInformations = '';
                $scope.datasetData = '';
                Information.hotTopInformations(function (data) {
                    if (data.result == 0) {
                        $scope.topInformations = data.datas.queryTopBanInformations;
                        $scope.datasetData = data.datas.queryTopNewInformations;
                        $rootScope.topInforSlideStop = $timeout(function () {
                            $scope.$apply(function () {
                                $ionicSlideBoxDelegate.$getByHandle('topInforSlide').update();
                                var curIndex = $ionicSlideBoxDelegate.$getByHandle('topInforSlide').currentIndex();
                                var maxIndex = $ionicSlideBoxDelegate.$getByHandle('topInforSlide').slidesCount() - 1;
                                var nextIndex = (curIndex >= maxIndex) ? 0 : curIndex + 1;
                                $ionicSlideBoxDelegate.$getByHandle('topInforSlide').slide(nextIndex);
                            });
                        }, 2000);
                    }
                });
            }
            $ionicLoading.show();
            $scope.moreData = true;
            $scope.pageNo = 1;
            $rootScope.currentSectionIndexId = patch;
            $rootScope.currentSectionIndexIndex = index;
            $scope.loadData(false);
            $scope.index = index;
            $scope.all_cate_num = $rootScope.categoryListMyColumn.length;
            var a = document.getElementById('sub_header_list').getElementsByTagName('a');
            for (var i = 0; i < $scope.all_cate_num; i++) {
                a[i].className = "button button-clear ";
            }
            //把点击的那个显示出来
            a[$rootScope.currentSectionIndexIndex].className = "button button-clear sub_button_select";
            $ionicScrollDelegate.$getByHandle('column_scroll').scrollTo($rootScope.currentSectionIndexIndex * ($scope.ScreenWidth / 4) - 50, 0, true);
            $ionicScrollDelegate.$getByHandle('news_list').scrollTop();
        };
        $scope.toggleLeftSideMenu = function () {
            $ionicSideMenuDelegate.toggleLeft();
        };
        $scope.search = function () {
            window.open('http://www.suzhou.gov.cn/wcm/dev/app_search_input.jsp', '_blank');
        };
        //内容详情
        $scope.openView = function (item) {
            if (item.id != '') {
                $state.go("homeDetail", {"id": item.id, "docSource": item.docSource, "nickcrUser": item.nickcrUser}, {reload: true});
            }
        };
        //英文版内容
        $scope.openEnglish = function () {
            window.open('http://english.suzhou.gov.cn/index_1427.shtml', '_system');
        };
        //移动政务群
        $scope.open = function () {
            window.open('http://www.suzhou.gov.cn/sy/app/ydzwq.html', '_system');
        };
        $ionicLoading.hide();
    }])
    .controller('informationListController', ['$scope', '$http', '$rootScope', '$interval', '$ionicSlideBoxDelegate', '$ionicTabsDelegate', '$ionicScrollDelegate', '$state', 'Media', 'Information', 'Section', '$timeout', 'Storage', function ($scope, $http, $rootScope, $interval, $ionicSlideBoxDelegate, $ionicTabsDelegate, $ionicScrollDelegate, $state, Media, Information, Section, $timeout, Storage) {
    }])
    .controller('informationDetailController', ['$rootScope', '$scope', '$sce', '$stateParams', '$timeout', '$interval', '$ionicHistory', '$ionicPopup', '$ionicModal', 'Information', 'Config', 'Storage', 'IsOrNotToast', function ($rootScope, $scope, $sce, $stateParams, $timeout, $interval, $ionicHistory, $ionicPopup, $ionicModal, Information, Config, Storage, IsOrNotToast) {
        $scope.$on('$ionicView.beforeEnter', function () {
            $timeout.cancel($rootScope.topInforSlideStop);
            //页面刚加载的时候判断字体
            $scope.c_size_key = Storage.get('c_size');
            //初始化字号
            if (!$scope.c_size_key) {
                $scope.c_size_key = 'C';
                $scope.textSizeName = "中";
            }
            if (!$scope.c_size_key) {
                $scope.c_size = '16';
                $scope.c_size_key = 'D';
                $scope.textSizeName = "小";
            }
            if ($scope.c_size_key == 'A') {
                $scope.c_size = '22';
                $scope.textSizeName = "特大";
            } else if ($scope.c_size_key == 'B') {
                $scope.c_size = '20';
                $scope.textSizeName = "大";
            }
            else if ($scope.c_size_key == 'C') {
                $scope.c_size = '18';
                $scope.textSizeName = "中";
            } else if ($scope.c_size_key == 'D') {
                $scope.c_size = '16';
                $scope.textSizeName = "小";
            }
            $scope.d = {
                size: $scope.c_size_key
            };
        });
        $scope.showloading = true;
        var imageDefault = Config.server + "www/img/zgsz.png";
        //详情内容
        Information.getInformation($stateParams.id, window.localStorage.userId, function (datas) {
            $scope.showloading = false;
            $scope.informationDetail = datas;
            $scope.docSource = $stateParams.docSource;
            $scope.nickcrUser = $stateParams.nickcrUser;
        });
        //返回
        $scope.goBack = function () {
            $ionicHistory.goBack(-1);
        };
        //设置字体
        $scope.font_size = [
            {text: "特大字号", value: "A"},
            {text: "大字号", value: "B"},
            {text: "中字号", value: "C"},
            {text: "小字号", value: "D"}
        ];
        $scope.d = {
            size: $scope.c_size_key
        };
        //字体设置大小
        $scope.newsContentFontSize = function () {
            // 调用$ionicPopup弹出定制弹出框
            $ionicPopup.show({
                templateUrl: "templates/information/font-size.html",
                title: "正文字体",
                scope: $scope,
                buttons: [
                    {text: "取消"},
                    {
                        text: "<b>确定</b>",
                        type: "button-positive",
                        onTap: function (e) {
                            if ($scope.d.size == 'A') {
                                $scope.c_size = '22';
                                $scope.textSizeName = "特大";
                            } else if ($scope.d.size == 'B') {
                                $scope.c_size = '20';
                                $scope.textSizeName = "大";
                            }
                            else if ($scope.d.size == 'C') {
                                $scope.c_size = '18';
                                $scope.textSizeName = "中";
                            } else if ($scope.d.size == 'D') {
                                $scope.c_size = '16';
                                $scope.textSizeName = "小";
                            } else {
                                $scope.c_size = '16';
                                $scope.textSizeName = "小";
                            }
                            Storage.set('c_size', $scope.d.size);
                        }
                    }
                ]
            })
        };
        //内容收藏
        $scope.collected = function (informationDetail) {
            if ($scope.showloading) {
                return;
            }
            Information.collected(informationDetail.id, window.localStorage.userId, function (data) {
                if (data.result == 0) {
                    $scope.$apply(function () {
                        informationDetail.collected = data.datas.collected;
                    });
                } else {
                    IsOrNotToast.toast(data.message);
                }
            })
        };
        //内容点赞
        $scope.praised = function (informationDetail) {
            if ($scope.showloading) {
                return;
            }
            Information.praised(informationDetail.id, window.localStorage.userId, function (data) {
                if (data.result == 0) {
                    $scope.$apply(function () {
                        informationDetail.praised = data.datas.praised;
                        informationDetail.praise = data.datas.praise;
                    });
                } else {
                    IsOrNotToast.toast(data.message);
                }
            })
        };
        $ionicModal.fromTemplateUrl('templates/shareModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.shareModal = modal;
        });
        //分享弹窗页面
        $scope.shared = function () {
            $scope.shareModal.show();
        };
        $scope.$on('$destroy', function () {
            $scope.shareModal.remove();
        });
        //关闭分享弹窗
        $scope.closeShard = function () {
            $scope.shareModal.hide();
        };
        //分享到QQ好友
        $scope.shareToQQ = function (item) {
            $scope.shareModal.hide();
            if ($scope.showloading) {
                return;
            }
            var title = item.title;
            var description = item.title;
            var id = item.id.replace(/\//g, '%252F');
            if (item.url != undefined && item.url != "") {
                var img = item.url;
            } else {
                var img = imageDefault;
            }
            var args = {};
            args.url = Config.share + id;
            args.title = title;
            args.description = description;
            args.imageUrl = img;
            args.appName = "中国苏州";
            YCQQ.shareToQQ(function () {
                $scope.shareModal.hide();
            }, function (failReason) {
                console.log(failReason);
                $scope.shareModal.hide();
            }, args);
        };
        //分享到QQ空间
        $scope.shareToQzone = function (item) {
            $scope.shareModal.hide();
            if ($scope.showloading) {
                return;
            }
            var title = item.title;
            var description = item.title;
            var id = item.id.replace(/\//g, '%252F');
            if (item.url != undefined && item.url != "") {
                var img = [item.url];
            } else {
                var img = [imageDefault];
            }
            var args = {};
            args.url = Config.share + id;
            args.title = title;
            args.description = description;
            var imgs = img;
            args.imageUrl = imgs;
            YCQQ.shareToQzone(function () {
                $scope.shareModal.hide();
            }, function (failReason) {
                console.log(failReason);
                $scope.shareModal.hide();
            }, args);
        };
        //分享到微信好友
        $scope.shareToWechatFrend = function (item) {
            $scope.shareModal.hide();
            if ($scope.showloading) {
                return;
            }
            var title = item.title;
            var description = item.title;
            var id = item.id.replace(/\//g, '%252F');
            if (item.url != undefined && item.url != "") {
                var img = [item.url];
            } else {
                var img = [imageDefault];
            }
            Wechat.share({
                message: {
                    title: title,
                    description: description,
                    thumb: img,
                    media: {
                        type: Wechat.Type.WEBPAGE,
                        webpageUrl: Config.share + id
                    }
                },
                scene: Wechat.Scene.SESSION   // share to 微信好友
            }, function () {
                $scope.shareModal.hide();
            }, function (reason) {
                console.log(reason);
                $scope.shareModal.hide();
            });
        };
        //分享到微信朋友圈
        $scope.shareToWechatCircle = function (item) {
            $scope.shareModal.hide();
            if ($scope.showloading) {
                return;
            }
            var title = item.title;
            var description = item.title;
            var id = item.id.replace(/\//g, '%252F');
            if (item.url != undefined && item.url != "") {
                var img = [item.url];
            } else {
                var img = [imageDefault];
            }
            Wechat.share({
                message: {
                    title: title,
                    description: description,
                    thumb: img,
                    media: {
                        type: Wechat.Type.WEBPAGE,
                        webpageUrl: Config.share + id
                    }
                },
                scene: Wechat.Scene.TIMELINE   // share to 朋友圈
            }, function () {
                $scope.shareModal.hide();
            }, function (reason) {
                console.log(reason);
                $scope.shareModal.hide();
            });
        };
        //分享到微博
        $scope.shareToWeibo = function (item) {
            $scope.shareModal.hide();
            if ($scope.showloading) {
                return;
            }
            var title = item.title;
            var description = item.title;
            var id = item.id.replace(/\//g, '%252F');
            if (item.url != undefined && item.url != "") {
                var img = item.url;
            } else {
                var img = imageDefault;
            }
            var args = {};
            args.title = title;
            args.url = Config.share + id;
            args.imageUrl = img;
            args.defaultText = "";
            YCWeibo.shareToWeibo(function () {
                console.log("share sueeess");
                $scope.shareModal.hide();
            }, function (failReason) {
                console.log(failReason);
                $scope.shareModal.hide();
            }, args);
        };
    }])
    .controller('officeHallCenterController', ['$rootScope', '$scope', '$interval', function ($rootScope, $scope, $interval) {
        $scope.$on('$ionicView.beforeEnter', function () {
            $interval.cancel($rootScope.dynamicScrollStop);
        });
        $scope.a = function () {
            window.open('http://www.suzhou.gov.cn/sy/wap/fwdt-wap-list.html', '_system');
        }
        $scope.b = function () {
            window.open('http://www.suzhou.gov.cn/sy/wap/hddt-wap-list.html', '_system');
        }
        $scope.c = function () {
            window.open('http://www.suzhou.gov.cn/sy/wap/xxgk-wap-list.html', '_system');
        }
        $scope.search = function () {
            window.open('http://www.suzhou.gov.cn/wcm/dev/app_search_input.jsp', '_system');
        }
    }])
    .controller('mobileOfficeController', ['$rootScope', '$scope', function ($rootScope, $scope) {
        $scope.$on('$ionicView.beforeEnter', function () {
            $rootScope.isfool = false;
        });
    }])
    .controller('feedbackController', ['$scope', function ($scope) {
    }])
    //用户收藏列表
    .controller('userCollectController', ['$scope', '$ionicHistory', '$ionicListDelegate', '$ionicSideMenuDelegate', '$ionicTabsDelegate', '$state', 'Information', '$ionicLoading', 'Media', function ($scope, $ionicHistory, $ionicListDelegate, $ionicSideMenuDelegate, $ionicTabsDelegate, $state, Information, $ionicLoading, Media) {
        $scope.pageNo = 1;
        $scope.pageSize = 10;
        $scope.moreDataLate = true;
        $scope.moreDataCollCanBeLoaded = true;
        var n = 1;
        //返回
        $scope.goBack = function () {
            $ionicHistory.goBack(-1);
            document.removeEventListener('backbutton', $scope.goBack, false);
        };
        document.addEventListener('backbutton', $scope.goBack, false);
        //向下拉刷新
        $scope.refresh = function () {
            //加载资讯列表
            $scope.pageNo = 1;
            $scope.moreDataLate = true;
            $scope.loadData(false);
        };
        //向上拉加载更多
        $scope.loadMore = function () {
            if (!$scope.moreDataLate) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                return;
            }
            $scope.pageNo++;
            $scope.loadData(true);
        };
        $scope.loadData = function (append) {
            if (!$scope.moreDataLate) {
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $ionicLoading.hide();
                return;
            }
            if (!append) {
                if (!$scope.$$phase) {
                    $scope.$apply(function () {
                        $scope.informations = [];
                    });
                } else {
                    $scope.informations = [];
                }
            }
            $scope.moreDataLate = false;
            Information.getUserCollectById(window.localStorage.userId, $scope.pageNo, $scope.pageSize, function (datas) {
                if (datas != undefined) {
                    $scope.moreDataLate = datas.length > 0;
                    for (var i = 0; i < datas.length; i++) {
                        $scope.informations.push(datas[i]);
                    }
                    if (datas.length == 0 && n == 1 || $scope.pageNo == 1 && n == 2 && $scope.informations.length == 0) {
                        $scope.message = "无收藏记录";
                    } else {
                        n = 2;
                    }
                    if (datas.length == $scope.pageSize) {
                        $scope.moreDataCollCanBeLoaded = true;
                    } else {
                        $scope.moreDataCollCanBeLoaded = false;
                    }
                } else if (datas == undefined && $scope.pageNo == 1) {
                    $scope.message = "无收藏记录";
                }
                $ionicLoading.hide();
                $scope.$broadcast('scroll.refreshComplete');
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $('#loading-backdrop').remove();
                $('#loading-container').remove();
            });
        };
        //取消收藏
        $scope.removeCollec = function (item) {
            Information.collected(item.id, window.localStorage.userId, function (data) {
                if (data.result == 0) {
                    $scope.$apply(function () {
                        item.collected = data.datas.collected;
                        $scope.informations.splice($scope.informations.indexOf(item), 1);
                        $ionicListDelegate.closeOptionButtons();
                        Information.getUserCollectById(window.localStorage.userId, 1, $scope.pageSize, function (datas) {
                            if (datas != undefined) {
                                $scope.informations = datas;
                                if (datas.length == 0 && n == 1 || $scope.pageNo == 1 && n == 2 && $scope.informations.length == 0) {
                                    $scope.message = "无收藏记录";
                                } else {
                                    n = 2;
                                }
                            } else if (datas == undefined) {
                                $scope.message = "无收藏记录";
                            }
                        });
                    });
                } else {
                    IsOrNotToast.toast(data.message);
                }
                return false;
            });
        };
        //内容详情
        $scope.openView = function (item) {
            if (item.id != '') {
                $state.go("homeDetail", {"id": item.id}, {reload: true});
            }
        };
        $scope.loadData(false);
    }])
    ;