angular.module('starter.directive', [])
    .directive('hideTabs', function ($rootScope) {
        return {
            restrict: 'AE',
            link: function ($scope) {
                $scope.$on('$ionicView.beforeEnter', function () {
                    $rootScope.hideTabs = 'tabs-item-hide';
                    console.log('tabs-item-hide');
                });
                $scope.$on('$destroy', function () {
                    $rootScope.hideTabs = '';
                    console.log('no-tabs-item-hide');
                })
            }
        }
    })
    .directive('setFocus', function () {
        return function (scope, element) {
            element[0].focus();
        };
    }).directive('repeatFinish', function () {
        return {
            link: function (scope, element, attr) {
                if (scope.$last == true) {
                    scope.$eval(attr.repeatFinish);
                }
            }
        }
    })
    .filter('formatTime', function () {
        return function (createDate) {
            //将字符串转换成时间格式
            var timeNow = new Date();
            var timePublish = new Date(createDate);
            var currentHours = timeNow.getHours();
            var minute = 1000 * 60;
            var hour = minute * 60;
            var day = hour * 24;
            var month = day * 30;
            var diffValue = timeNow - timePublish;
            var diffMonth = diffValue / month;
            var diffWeek = diffValue / (7 * day);
            var diffDay = diffValue / day;
            var diffHour = diffValue / hour;
            var diffMinute = diffValue / minute;
            var strYear = timePublish.getFullYear();
            var strMonth = timePublish.getMonth() + 1;
            strMonth = strMonth < 10 ? '0' + strMonth : strMonth;
            var strDate = timePublish.getDate() < 10 ? '0' + timePublish.getDate() : timePublish.getDate();
            var strHour = timePublish.getHours() < 10 ? '0' + timePublish.getHours() : timePublish.getHours();
            var strMinute = timePublish.getMinutes() < 10 ? '0' + timePublish.getMinutes() : timePublish.getMinutes();
            result = strYear + "-" + strMonth + "-" + strDate + " " + strHour + ":" + strMinute;
            return result;
        }
    })
    .directive("slideFollow", ['$timeout', '$interval', function ($timeout, $interval) {
        return {
            restrict: 'E',
            replace: true,
            terminal: false,
            scope: {
                openView: '&',
                id: "@",
                datasetData: "="
            },
            template: "<li ng-repeat = 'data in datasetData' ng-click='openView(data)'>{{data.title}}</li>",
            link: function (scope, elem, attrs) {
                $timeout(function () {
                    var className = $("." + $(elem).parent()[0].className);
                    var i = 0, sh;
                    var liLength = className.children("li").length - 1;
                    var liHeight = className.children("li").height() + parseInt(className.children("li").css('border-bottom-width'));
                    //className.html(className.html() + className.html());
                    // 开启定时器
                    function slide() {
                        if (parseInt(className.css("margin-top")) > (-liLength * liHeight)) {
                            i++;
                            className.animate({
                                marginTop: -liHeight * i + "px"
                            }, "slow");
                        } else {
                            i = 0;
                            //className.css("margin-top", "0px");
                            className.animate({
                                marginTop: "0px"
                            }, "slow");
                        }
                    }

                    $interval(slide, 4000);
                    /*                    // 清除定时器
                     className.click(function () {
                     console.log(123)
                     clearInterval(sh);
                     }, function () {
                     console.log(elem);
                     clearInterval(sh);
                     sh = setInterval(slide, 4000);
                     })*/
                }, 0)
            }
        }
    }]);