angular.module('starter.services', ['td.config'])
    .constant("$ionicLoadingConfig", {
        template: '<img src="img/loading.gif" width="100%" height="100%" style="border-radius:5px;display: block;"/>',
        noBackdrop: false
    })
    .factory('jpushService', ['$http', '$window', '$document', function ($http, $window, $document) {
        var jpushServiceFactory = {};
//        var jpushapi = $window.plugins.jPushPlugin;
        //启动极光推送
        var _init = function (config) {
            $window.plugins.jPushPlugin.init();
            //设置tag和Alias触发事件处理
            document.addEventListener('jpush.setTagsWithAlias', config.stac, false);
            //打开推送消息事件处理
            $window.plugins.jPushPlugin.openNotificationInAndroidCallback = config.oniac;
            $window.plugins.jPushPlugin.setDebugMode(true);
        }
        //获取状态
        var _isPushStopped = function (fun) {
            $window.plugins.jPushPlugin.isPushStopped(fun);
        }
        //停止极光推送
        var _stopPush = function () {
            $window.plugins.jPushPlugin.stopPush();
        }
        //重启极光推送
        var _resumePush = function () {
            $window.plugins.jPushPlugin.resumePush();
        }
        //设置标签和别名
        var _setTagsWithAlias = function (tags, alias) {
            $window.plugins.jPushPlugin.setTagsWithAlias(tags, alias);
        }
        //设置标签
        var _setTags = function (tags) {
            $window.plugins.jPushPlugin.setTags(tags);
        }
        //设置别名
        var _setAlias = function (alias) {
            $window.plugins.jPushPlugin.setAlias(alias);
        }
        jpushServiceFactory.init = _init;
        jpushServiceFactory.isPushStopped = _isPushStopped;
        jpushServiceFactory.stopPush = _stopPush;
        jpushServiceFactory.resumePush = _resumePush;
        jpushServiceFactory.setTagsWithAlias = _setTagsWithAlias;
        jpushServiceFactory.setTags = _setTags;
        jpushServiceFactory.setAlias = _setAlias;
        return jpushServiceFactory;
    }])
    .factory('Storage', function () {
        return {
            set: function (key, data) {
                //  return window.localStorage.setItem(key, window.JSON.stringify(data));
                return window.localStorage.setItem(key, angular.toJson(data));
            },
            get: function (key) {
                return window.JSON.parse(window.localStorage.getItem(key));
            },
            remove: function (key) {
                return window.localStorage.removeItem(key);
            }
        };
    })
    .service('Media', ['$timeout', function ($timeout) {
        this.ready = function () {
            var videoWidth = document.body.clientWidth - 20;
            var videoHeight = videoWidth * 0.6;
            var audioWidth = 400;
            var audioHeight = 30;
            $('video').mediaelementplayer({
                // if the <video width> is not specified, this is the default
                defaultVideoWidth: videoWidth,
                // if the <video height> is not specified, this is the default
                defaultVideoHeight: videoHeight,
                // if set, overrides <video width>
                videoWidth: videoWidth,
                // if set, overrides <video height>
                videoHeight: videoHeight,
                pluginWidth: videoWidth,
                pluginHeight: videoHeight,
                // width of audio player
                audioWidth: audioWidth,
                // height of audio player
                audioHeight: audioHeight,
                // initial volume when the player starts
                startVolume: 0.8,
                // useful for <audio> player loops
                loop: false,
                // enables Flash and Silverlight to resize to content size
                enableAutosize: true,
                // the order of controls you want on the control bar (and other
                // plugins below)
                //  features: ['playpause', 'progress', 'current', 'duration', 'tracks', 'volume', 'fullscreen'],
                features: ['playpause', 'progress', 'current', 'duration', 'tracks', 'volume', 'fullscreen'],
                // Hide controls when playing and mouse is not over the video
                alwaysShowControls: false,
                // force iPad's native controls
                iPadUseNativeControls: false,
                // force iPhone's native controls
                iPhoneUseNativeControls: false,
                // force Android's native controls
                AndroidUseNativeControls: false,
                // forces the hour marker (##:00:00)
                alwaysShowHours: false,
                // show framecount in timecode (##:00:00:00)
                showTimecodeFrameCount: false,
                // used when showTimecodeFrameCount is set to true
                framesPerSecond: 25,
                // turns keyboard support on and off for this instance
                enableKeyboard: true,
                // when this player starts, it will pause other players
                pauseOtherPlayers: true,
                // array of keyboard commands
                keyActions: []
            }).css({
                width: videoWidth,
                height: videoHeight
            });
        };
        this.resizeImg = function () {
            var bannerWidth = document.body.clientWidth;
            var bannerHeight = bannerWidth * 0.55;
            $('.default-banner-img').css({
                width: bannerWidth,
                height: bannerHeight
            });
        };
    }])
    //弹出对话框(1.有插件;2.没插件)
    .service('IsOrNotToast', function () {
        this.toast = function (message) {
            if (window.plugins && window.plugins.toast) {
                window.plugins.toast.showWithOptions({
                    message: message,
                    duration: 'short',
                    position: 'bottom',
                    addPixelsY: -120
                });
            } else {
                alert(message);
            }
        }
    })
    .service('Section', ['$http', 'Config', 'IsOrNotToast', function ($http, Config, IsOrNotToast) {
        //列表栏目  /*http://192.168.1.101:8080/zgsz-app-server/section.do?method=querySections&menuId=http://www.suzhou.gov.cn/news/sxqdt/index_1401.htm*/
        this.querySections = function (callBack) {
            $.ajax({
                type: 'Get',
                url: Config.server + "section.do",
                data: {
                    method: 'querySections',
                    menuId: Config.sectionUrl
                },
                async: true,
                dataType: "json",
                success: function (data) {
                    callBack(data.datas);
                },
                error: function () {
                    callBack("-1");
                    IsOrNotToast.toast("网络不给力，请检查网络设置。");
                }
            });
        };
    }])
    .service('Information', ['$http', 'Config', 'IsOrNotToast', '$rootScope', 'downloadImage', '$interval', function ($http, Config, IsOrNotToast, $rootScope, downloadImage, $interval) {
        //热点推荐 单独接口   /* http://localhost:8080/zgsz-app-server/information.do?method=queryTopInformations */
        this.hotTopInformations = function (callBack) {
            $.ajax({
                type: 'Get',
                url: Config.server + "information.do",
                data: {
                    method: 'queryTopInformations'
                },
                async: true,
                dataType: "json",
                success: function (data) {
                    callBack(data);
                },
                error: function () {
                    IsOrNotToast.toast("网络不给力，请检查网络设置。");
                }
            });
        };
        //列表内容  /* http://localhost:8080/zgsz-app-server/information.do?method=queryInformations&menuId=http://www.suzhou.gov.cn/news/szxw/index_1401.htm&userId=160a3797c80a80933ec&pageNo=2&pageSize=10 */
        this.queryInformations = function (menuId, userId, pageNo, pageSize, callBack) {
            $.ajax({
                type: 'Get',
                url: Config.server + "information.do",
                data: {
                    method: 'queryInformations',
                    menuId: menuId,
                    userId: userId,
                    pageNo: pageNo,
                    pageSize: pageSize
                },
                async: true,
                dataType: "json",
                success: function (data) {
                    //callBack(data);
                    if (data.result == 0 && data.datas != undefined && data.datas.length > 0) {
                        var result = [];
                        var count = 0;
                        for (var i = 0; i < data.datas.length; i++) {
                            var item = data.datas[i];
                            if (item.url) {
                                count++;
                                downloadImage.download(item.url, {item: item}, function (data, obj) {
                                    result.push(1);
                                    obj.item.url = data;
                                });
                            }
                        }
                        var timer = $interval(
                            function () {
                                if (result.length == count) {
                                    callBack(data.datas);
                                    $interval.cancel(timer);
                                }
                            }, 100);
                    } else {
                        var datas = [];
                        callBack(datas);
                    }
                },
                error: function () {
                    callBack("-1");
                    IsOrNotToast.toast("网络不给力，请检查网络设置。");
                }
            });
        };
        //内容详情页  /*http://192.168.1.103:8080/zgsz-app-server/information.do?method=getInformation&informationId=http://www.suzhou.gov.cn/news/szxw/201611/t20161103_791563_1097.html&userId=160a3797c80a80933ec*/
        this.getInformation = function (informationId, userId, callBack) {
            $.ajax({
                type: 'Get',
                url: Config.server + "information.do",
                data: {
                    method: 'getInformation',
                    informationId: informationId,
                    userId: userId
                },
                async: true,
                dataType: "json",
                success: function (data) {
                    callBack(data.datas);
                },
                error: function () {
                    IsOrNotToast.toast("网络不给力，请检查网络设置。");
                }
            });
        };
        //内容收藏 //http://192.168.1.103:8080/zgsz-app-server/information.do?method=collected&informationId=http://www.suzhou.gov.cn/news/szxw/201611/t20161104_792058_1097.html&userId=160a3797c80a80933ec
        this.collected = function (informationId, userId, callBack) {
            $.ajax({
                type: 'Get',
                url: Config.server + "information.do",
                data: {
                    method: 'collected',
                    informationId: informationId,
                    userId: userId
                },
                async: true,
                dataType: "json",
                success: function (data) {
                    callBack(data);
                },
                error: function () {
                    IsOrNotToast.toast("网络不给力，请检查网络设置。");
                }
            });
        };
        //内容点赞 //  http://192.168.1.103:8080/zgsz-app-server/information.do?method=praised&informationId=http://www.suzhou.gov.cn/news/szxw/201611/t20161104_792060_1097.html&userId=160a3797c80a80933ec
        this.praised = function (informationId, userId, callBack) {
            $.ajax({
                type: 'Get',
                url: Config.server + "information.do",
                data: {
                    method: 'praised',
                    informationId: informationId,
                    userId: userId
                },
                async: true,
                dataType: "json",
                success: function (data) {
                    callBack(data);
                },
                error: function () {
                    IsOrNotToast.toast("网络不给力，请检查网络设置。");
                }
            });
        };
        //用户收藏列表
        this.getUserCollectById = function (userId, pageNo, pageSize, callBack) {
            $.ajax({
                type: 'Get',
                url: Config.server + "information.do",
                data: {
                    method: 'getUserCollectById',
                    userId: userId,
                    pageNo: pageNo,
                    pageSize: pageSize
                },
                async: false,
                dataType: "json",
                success: function (data) {
                    callBack(data.datas);
                },
                error: function () {
                    IsOrNotToast.toast("网络不给力，请检查网络设置。");
                }
            });
        };
        //意见反馈
        this.submit = function (content, userId, callBack) {
            $.ajax({
                type: 'Get',
                url: Config.server + "feedback.do",
                data: {
                    method: 'submit',
                    content: content,
                    userId: userId
                },
                async: true,
                dataType: "json",
                success: function (data) {
                    callBack(data);
                },
                error: function () {
                    IsOrNotToast.toast("网络不给力，请检查网络设置。");
                }
            });
        };
    }])
    //版本号获取
    .service('appVersion', ['$http', 'Config', 'IsOrNotToast', function ($http, Config, IsOrNotToast) {
        this.getVersion = function (callBack) {
            $.ajax({
                type: 'Get',
                url: Config.server + "system.do",
                data: {
                    method: 'getVersion'
                },
                async: false,
                dataType: "json",
                success: function (data) {
                    callBack(data);
                },
                error: function () {
                    IsOrNotToast.toast("网络不给力，请检查网络设置。");
                }
            });
        }
    }])
    // 图片下载到本地
    .service('downloadImage', function () {
        function hash(str) {
            var hash = 0;
            for (var i = 0; i < str.length; i++) {
                var char = str.charCodeAt(i);
                hash += char;
            }
            var str = parseInt(hash % 256).toString(16);
            if (str.length == 1) {
                return 0 + str;
            }
            return str;
        }

        var targerDir = 'zgsz/images/';
        // 下载图片
        this.download = function (url, obj, callBack) {
            if (!window.cordova || !cordova.file || !cordova.file.dataDirectory) {
                callBack(url, obj);
                return url;
            }
            var md5 = new Hashes.MD5;
            var sha1 = new Hashes.SHA1;
            var s_md5 = md5.hex(url);
            var s_sha1 = sha1.hex(url);
            var fileName = s_md5;
            var targetDirPath = targerDir + hash(s_md5) + '/' + hash(s_sha1);
            var targetPath = targerDir + hash(s_md5) + '/' + hash(s_sha1) + '/' + fileName;
            // 判断该图片路径是否存在
            window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
                var dirReader = fs.root;
                // 新建文件夹
                dirReader.getDirectory(targetDirPath, {create: true}, function (dirEntry) {
                        // 文件夹存在
                    },
                    // 新建文件夹
                    createDir(dirReader, targetDirPath.split('/'), function (data) {
                        if (data == -1) {
                            callBack(url, obj);
                        }
                    }));
                // 新建文件
                dirReader.getFile(targetPath, {create: true, exclusive: false}, function (fileEntry) {
                        fileEntry.file(function (fileObj) {
                            // 读取文件，若文件大小为0，则不存在，新建文件（下载图片）
                            if (fileObj.size == 0) {
                                var fileTransfer = new FileTransfer();
                                var fileURL = fileEntry.toURL();
                                fileTransfer.download(encodeURI(url), fileURL, function (entry) {
                                        // 图片下载成功。异步下载，花费时间，先把之前的url
                                        // 返回
                                        callBack(url, obj);
                                    },
                                    function (error) {
                                        // 图片下载失败
                                        callBack(url, obj);
                                    },
                                    true);
                            } else {
                                // 之前下载好的图片，把路径返回
                                callBack(fileEntry.nativeURL, obj);
                            }
                        });
                    },
                    function onErrorCreateFile() {
                        // 文件创建失败
                        callBack(url, obj);
                    });
            }, function onErrorLoadFs() {
                // LocalFileSystem 读取失败
                callBack(url, obj);
            });
        };
        // 遍历文件夹，统计文件大小
        this.totalDirSize = function (callBack) {
            if (!window.cordova || !cordova.file
                || !cordova.file.dataDirectory) {
                callBack(-1);
                return;
            }
            window.requestFileSystem(LocalFileSystem.PERSISTENT, 0,
                function (fs) {
                    var totalSize = 0;
                    getDirSize(fs.root, targerDir, function (data) {
                        if (data != -1) {
                            // 清除成功返回总文件夹大小
                            var fileSize = data;
                            totalSize += fileSize;
                            callBack(bytesToSize(totalSize));
                        } else {
                            callBack(data);
                        }
                    });
                });
        };
        // 清除缓存本地图片等
        this.removeDir = function (callBack) {
            if (!window.cordova || !cordova.file || !cordova.file.dataDirectory) {
                callBack(-1);
                return;
            }
            window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fs) {
                var rootDir = fs.root;
                rootDir.getDirectory(targerDir, {}, function (dirEntry) {
                        // 创建一个目录读取器
                        var directory = dirEntry.createReader();
                        directory.readEntries(function (entries) {
                            if (entries.length >= 0) {
                                // 清理文件，找到下级目录，清除下级目录
                                var sum = 0;
                                for (var i = 0; i < entries.length; i++) {
                                    sum++;
                                    rootDir.getDirectory(entries[i].fullPath, {}, function (dirEntry) {
                                        dirEntry.removeRecursively(function () {
                                        }, function errorHandler() {
                                            // 文件夹不存在
                                            callBack('1');
                                        });
                                    });
                                }
                                if (sum == entries.length) {
                                    // 清除成功
                                    callBack('1');
                                }
                            } else {
                                // 没有要清理的文件
                                callBack('1');
                            }
                        });
                    },
                    function errorHandler() {
                        // 文件夹不存在
                        callBack('1');
                    });
            });
        };
        // 创建文件夹
        function createDir(rootDirEntry, folders, callBack) {
            // 文件夹不存在，新建文件夹
            if (folders.length) {
                rootDirEntry.getDirectory(folders[0], {
                        create: true
                    },
                    function (dirEntry) {
                        createDir(dirEntry, folders.slice(1),
                            callBack);
                    }, function errorHandler() {
                        // 创建文件夹失败
                        callBack("-1");
                    });
            }
        }

        // 获取文件夹大小方法
        function getDirSize(rootDir, targerDir, callBack) {
            rootDir.getDirectory(targerDir, {}, function (dirEntry) {
                // 创建一个目录读取器
                var directory = dirEntry.createReader();
                directory.readEntries(function (entries) {
                    for (var i = 0; i < entries.length; i++) {
                        if (entries[i].isDirectory == true) {
                            getDirSize(rootDir, entries[i].fullPath, callBack);
                        } else {
                            rootDir.getFile(entries[i].fullPath, {}, function (fileEntry) {
                                    fileEntry.file(function (file) {
                                            // 获取文件大小返回
                                            callBack(file.size);
                                        },
                                        function onErrorLoadFs() {
                                            // 该文件不存在
                                            callBack("-1");
                                        });
                                },
                                function onErrorLoadFs() {
                                    // 该文件不存在
                                    callBack("-1");
                                });
                        }
                    }
                });
            });
        }

        // 内存大小单位换算方法
        function bytesToSize(bytes) {
            if (bytes === 0)
                return '0 B';
            var k = 1024;
            var sizes = ['B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB',
                'ZB', 'YB'];
            i = Math.floor(Math.log(bytes) / Math.log(k));
            return (bytes / Math.pow(k, i)).toPrecision(3) + ' ' + sizes[i];
            // toPrecision(3) 后面保留一位小数，如1.0GB //return (bytes /
            // Math.pow(k, i)).toPrecision(3) + ' ' + sizes[i];
        }
    });